data ex50;
input
N    B     L     LL      LW;
datalines;
 1    1     1     8.8    5.6
 1    1     2     8.3    5.6
 1    1     3     7.4    5.0
 1    1     4     7.4    4.9
 1    1     5     7.0    4.3
 1    1     6     8.0    5.9
 1    1     7     3.5    2.2
 1    1     8     4.5    2.7
 1    1     9     7.2    5.1
 1    1    10     3.6    1.9
 1    2    11     8.1    5.0
 1    2    12     6.3    4.0
 1    2    13     6.1    4.1
 1    2    14     7.1    4.6
 1    2    15     5.5    3.3
 1    2    16     6.8    4.4
 1    2    17     6.5    4.1
 1    2    18     4.4    2.8
 1    2    19     3.6    2.1
 1    2    20     7.0    4.7
 1    3    21     8.2    4.5
 1    3    22     6.2    4.4
 1    3    23     5.7    3.4
 1    3    24     6.2    4.6
 1    3    25     3.7    2.2
 1    3    26     3.6    1.9
 1    3    27     2.3    1.7
 1    3    28     3.5    2.9
 1    3    29     1.2    0.9
 1    3    30     8.2    4.7
 2    1    31     7.0    5.1
 2    1    32     6.3    4.1
 2    1    33     6.4    4.2
 2    1    34     7.1    4.6
 2    1    35     6.9    4.5
 2    1    36     2.8    1.6
 2    1    37     6.1    4.1
 2    1    38     8.2    5.4
 2    1    39     3.9    2.5
 2    1    40     6.0    4.1
 2    2    41     7.0    4.3
 2    2    42     6.7    4.2
 2    2    43     6.2    4.3
 2    2    44     5.3    3.7
 2    2    45     2.6    1.4
 2    2    46     4.9    3.1
 2    2    47     5.4    3.7
 2    2    48     7.3    4.0
 2    2    49     2.2    1.1
 2    2    50     6.8    4.1
 2    3    51     8.2    5.3
 2    3    52     8.0    5.0
 2    3    53     5.6    3.6
 2    3    54     7.0    4.5
 2    3    55     6.0    3.9
 2    3    56     7.0    4.6
 2    3    57     2.9    1.9
 2    3    58     7.0    4.4
 2    3    59     4.2    2.9
 2    3    60     3.1    1.6
 3    1    61     6.8    4.0
 3    1    62     8.0    4.5
 3    1    63     8.5    5.0
 3    1    64     6.0    3.7
 3    1    65     8.0    4.6
 3    1    66     5.0    3.1
 3    1    67     4.2    2.3
 3    1    68     7.0    4.4
 3    1    69     3.6    1.9
 3    1    70     4.2    2.7
 3    2    71     9.1    5.8
 3    2    72     7.2    4.6
 3    2    73     5.5    2.8
 3    2    74    10.2    6.7
 3    2    75     7.7    5.2
 3    2    76     9.1    5.5
 3    2    77     3.9    2.1
 3    2    78     4.9    2.6
 3    2    79     3.3    1.8
 3    2    80     8.9    5.5
 3    3    81     6.1    4.6
 3    3    82     8.5    5.5
 3    3    83     7.3    5.0
 3    3    84     8.5    6.1
 3    3    85     7.8    5.1
 3    3    86     3.9    2.3
 3    3    87     5.1    3.1
 3    3    88     7.8    5.5
 3    3    89     7.1    4.7
 3    3    90     3.5    2.0
;

proc corr data=ex50;
var LL LW;
run;

data ex5;
set ex50;
trait='LL'; z=1; response=LL; output; /*z is a switch*/
trait='LW'; z=0; response=LW; output;
run;

/*bivariate analysis*/

/*UNR - variance for blocks for trait=LL is zero*/
proc mixed data=ex5 asycov scoring=10;
class B N L trait;
model response=trait/ddfm=KR;
random trait/sub=B type=unr vcorr v;
random trait/sub=N type=unr vcorr v;
random trait/sub=B*N type=unr;
repeated trait/sub=B*N*L type=unr;
run;

/*UNR - set variance for blocks for trait=LL is zero. Use dummy variable z as a switch*/
ods output covparms=cp;
proc mixed data=ex5 asycov covtest scoring=10;
class B N L trait;
model response=trait/ddfm=KR;
random z*trait/sub=B type=vc vcorr v;
random trait/sub=N type=unr vcorr v;
random trait/sub=B*N type=unr;
repeated trait/sub=B*N*L type=unr;
run;


proc glimmix data=ex5 asycov scoring=10;
class B N L trait;
model response=trait/ddfm=KR;
random z*trait/sub=B type=vc vcorr v;
*random trait/sub=B type=unr vcorr v;
random trait/sub=N type=unr vcorr v;
random trait/sub=B*N type=unr;
random trait/sub=B*N*L type=unr residual;
parms / pdata=cp;
nloptions gconv=1e-6;
run;

proc glimmix data=ex5 asycov scoring=10;
class B N L trait;
model response=trait trait*B trait*N/ddfm=KR;
random trait/sub=B*N type=unr;
random trait/sub=B*N*L type=unr residual;
covtest 'equal correlation '   general 0 0 -1 0 0 0,
                                       0 0 0 0 0 -1;
covtest 'plot correlation=0 '  general 0 0 1 0 0 0;
covtest 'leaf correlation=0 '  general 0 0 0 0 0 1;
*nloptions gconv=1e-6;
run;

/*UN(1) - set variance for blocks for trait=LL is zero. Use dummy variable z as a switch*/
data cp0;
set cp;
if _N_ in (4,7,10) then estimate=0;
run;

proc glimmix data=ex5 asycov scoring=10;
class B N L trait;
model response=trait/ddfm=KR;
random z*trait/sub=B type=vc vcorr v;
*random trait/sub=B type=unr vcorr v;
random trait/sub=N type=unr vcorr v;
random trait/sub=B*N type=unr;
random trait/sub=B*N*L type=unr residual;
parms / pdata=cp0 hold=4,7,10;
run;

data ex50;
set ex50;
if N=1 then Nitrogen=0;
if N=2 then Nitrogen=20;
if N=3 then Nitrogen=40;
label Nitrogen='Nitrogen (kg/ha)';
run;

proc template;
  define style styles.mystyle;
  parent=styles.default;
    style GraphData1 from GraphData1 /
          markersymbol='circle'   linestyle=1 contrastcolor=green;
    style GraphData2 from GraphData2 /
          markersymbol='triangle' linestyle=2 contrastcolor=red;
    style GraphData3 from GraphData3 /
          markersymbol='diamond'  linestyle=3 contrastcolor=blue;
    style GraphData4 from GraphData4 /
          markersymbol='square'   linestyle=4 contrastcolor=orange;
    style graphbackground from graphbackground / 
color=_undef_;   end;
run;

ods listing GPATH='d:\hpp\veroeff\17\correlation\revision\Examples' image_dpi=600 style=styles.mystyle;
ods graphics on/ reset border=off outputfmt=gif 
    imagename="Figure10" width=4in height=4in ;
ods html style=styles.mystyle;
proc sgplot data=ex50;
scatter y=LL x=LW/group=Nitrogen markerattrs=(size=10);
yaxis label='Leaf width (cm)';
xaxis label='Leaf length (cm)';
run;




